''*****************************************************************************
''
''
''	Asteroid class
''	Richard Eric M. Lope
''	http://rel.phatcode.net
''
''	
''
''*****************************************************************************

#include once "FBGFX.bi"
#include once "FBGL2D7.bi"

#include once "Vector2D.bi"
#include once "Matrix2D.bi"
#include once "Polygon.bi"
#include once "Sound.bi"
#include once "Explosion.bi"

#include once "Globals.bi"
#include once "Ship.bi"


#define MAX_ASTEROIDS 63
#define ASTEROID_MAX_HP 20

''*****************************************************************************
''
''
''
''*****************************************************************************
enum DRAW_MODE

	DRAW_NORMAL = 0,
	DRAW_COLOR,
	DRAW_WHITE
		
End Enum


''*****************************************************************************
''
''
''
''*****************************************************************************
type Asteroid

public:
	declare constructor()
	declare destructor()
	
	declare property IsActive() as integer
	declare property GetPoly() as Polygon
	declare property GetHp() as integer
	declare property GetRadius() as integer
	declare property GetPosition() as Vector2D
	declare property DecHp( byval value as integer )
	declare property SetDrawMode( byval value as integer )
	
	declare sub Init( byref Posi as Vector2D, byref Target as Vector2D,_ 
			   		  byval spd as single, byval Col as integer,_ 
			   		  byval NumVerts as integer, byval rads as single,_
			   		  byval ScaleX as single = 1.0f, byval ScaleY as single = 1.0f )
	declare sub Update( byref Fighter as ship, byval dt as single )
	declare sub Draw()
	
	declare sub Destroy()
	declare sub Kill()	
	
	'' Because engine crashes if I use GetPoly
	as Polygon Body
	
private:

	
	as integer  Active
	as single	Speed					'' Speed of movement
	as single	Angle					'' Current angle of rotation
	as single	Delta					'' Speed of rotation
	as single   TimeActive				'' Time in seconds the asteroid is in play 
	as single	HitTimer 				'' Time in seconds the asteroid blinks when hit
	as integer 	Radius
	as integer	Colour					'' Color of the asteroid
	as integer 	Hp						'' life of the asteroid
	 	
	as DRAW_MODE DrawMode

	as Vector2D Position  '' ditto dunno why
	as Vector2D Direction
	
End Type


type AsteroidFactory

public:

	declare constructor()
	declare destructor()
	
	declare property GetNumEntities() as Integer
	
	declare sub UpdateEntities( byref Fighter as Ship, byval dt as single )
	declare sub DrawEntities()
	declare sub KillAllEntities()
	declare sub HandleCollisions( byref Fighter as Ship )
		
	declare sub Spawn( byref Posi as Vector2D, byref Target as Vector2D,_ 
			   		   byval spd as single, byval Col as integer,_ 
			   		   byval NumVerts as integer, byval radius as single,_
			   		   byval ScaleX as single = 1.0f, byval ScaleY as single = 1.0f )

private:

	as integer NumEntities
	as Asteroid Asteroids(MAX_ASTEROIDS)
	
End Type
