''*****************************************************************************
''
''
''	Bonus class
''	Richard Eric M. Lope
''	http://rel.phatcode.net
''
''	
''
''*****************************************************************************

#include once "FBGFX.bi"
#include once "FBGL2D7.bi"

#include once "Vector2D.bi"
#include once "Matrix2D.bi"
#include once "Polygon.bi"
#include once "Sound.bi"
#include once "Explosion.bi"

#include once "Globals.bi"
#include once "Ship.bi"


#define MAX_BONUSES 3

''*****************************************************************************
''
''
''
''*****************************************************************************
''*****************************************************************************
''
''
''
''*****************************************************************************
type Bonus

public:
	declare constructor()
	declare destructor()
	
	declare property GetID() as integer
	declare property IsActive() as integer
	declare property GetPoly() as Polygon
	
	declare sub Init( byref Posi as Vector2D )
	declare sub Update( byref Fighter as ship, byval dt as single )
	declare sub Draw()
	
	declare sub Destroy()
	declare sub Kill()	
	
	'' Because engine crashes is I use GetPoly
	as Polygon Body
	
private:

	as integer  ID
	as integer  Active
	as single	Speed					'' Speed of movement
	as single	Angle					'' Current angle of rotation
	as single	Delta					'' Speed of rotation
	as single   TimeActive				'' Time in seconds the Bonus is in play 
	as single	Intensity 				'' Drawing intensity
	as integer 	Radius
	as GLuint	Colour					'' Color of the Bonus
	 	
	as Vector2D Position
	as Vector2D Direction
	
	
End Type


type BonusFactory

public:

	declare constructor()
	declare destructor()
	
	declare property GetNumEntities() as Integer
	
	declare sub UpdateEntities( byref Fighter as Ship, byval dt as single )
	declare sub DrawEntities()
	declare sub KillAllEntities()
	declare sub HandleCollisions( byref Fighter as Ship )
		
	declare sub Spawn( byref Posi as Vector2D )

private:

	as integer NumEntities
	as Bonus Bonuses(MAX_BONUSES)
	
End Type
