''*****************************************************************************
''
''
''	Polygon class
''	Richard Eric M. Lope
''	http://rel.phatcode.net
''
''	
''
''*****************************************************************************

#include once "FBGL2D7.bi"

#include once "Vector2D.bi"
#include once "Matrix2D.bi"

#ifndef POLYGON_BI
#define POLYGON_BI

#ifndef false
	const as integer FALSE = 0
	const as integer TRUE = NOT FALSE
#endif


''*****************************************************************************
''
''
''
''*****************************************************************************
type Projection
	Min as single
	Max as single
End Type

type Polygon
	
public:	
	'' constructors and destructors
	declare constructor()	
	declare constructor( byval NumVerts as integer, byval Radius as single, byval ScaleX as single = 1, byval ScaleY as single = 1 )	
	declare constructor( byval NumVerts as integer, Vertices() as Vector2D, byval ScaleX as single = 1, byval ScaleY as single = 1 )	
	declare destructor()	
	
	declare property Vertex( byval Index as integer ) as Vector2D
	declare property Normal( byval Index as integer ) as Vector2D
	
	declare sub Create( byval NumVerts as integer, byval Radius as single, byval ScaleX as single = 1, byval ScaleY as single = 1 )	
	declare sub Create( byval NumVerts as integer, Vertices() as Vector2D, byval ScaleX as single = 1, byval ScaleY as single = 1 )	
	 
	declare sub Reload( byval NumVerts as integer, Vertices() as Vector2D )
	declare sub ReloadScreenCoords( byval NumVerts as integer, Vertices() as Vector2D, byval RecalcNormals as integer = FALSE )
	
	declare sub Translate( byval x as single, byval y as single )
	declare sub Rotate( byval Degrees as integer)
	declare sub Scale( byval x as single, byval y as single )
	declare sub Transform()
	declare sub Reset()
	
	declare function Project( byref Axis as Vector2D ) as Projection 
	declare function Collide( byref P2 as Polygon ) as integer
	
	declare sub Draw( byval LineWidth as integer, byval colour as GLuint ) 
	declare sub DrawNormals( byval Length as single, byval colour as GLuint ) 
	
	
private:
	
	NumVertices	as integer
	
	CenterX 	as single
	CenterY		as single
	
	
	VerticesLocal	as Vector2D ptr = 0
	VerticesScreen	as Vector2D ptr = 0
	NormalsLocal	as Vector2D ptr = 0
	NormalsScreen	as Vector2D ptr = 0
	
	Transformation	as Matrix2D

end type

#endif

		