''*****************************************************************************
''
''
''	Shot class
''	Richard Eric M. Lope
''	http://rel.phatcode.net
''
''	
''
''*****************************************************************************

#include once "Shot.bi"

const as single SHOT_SPEED = 800

''*****************************************************************************
''
''
''
''*****************************************************************************
constructor Shot()	

	Active = FALSE
	Length = 20
	Position = Vector2D( -3600, -3600 )
	
	dim as Vector2D v(2)
	
	v(0) = Vector2D( 0, 0 )
	v(1) = Vector2D( 1, 1 )
	v(2) = Vector2D( 2, 2 )
	
	Body.Create( 3, v() )
	
	Body.Reset()
	Body.Translate( Position.x, Position.y )
	Body.Transform()
	
	
End Constructor

destructor Shot()	

End Destructor

''*****************************************************************************
''
''
''
''*****************************************************************************	
property Shot.IsActive() as integer
	property = Active
End Property

property Shot.GetPosition() as Vector2D
	property = Position
End Property

property Shot.GetDirection() as Vector2D
	property = Direction
End Property

property Shot.GetHeading() as Vector2D
	property = Heading
End Property

property Shot.GetPower() as integer
	property = Power
End Property

property Shot.GetAngle() as integer
	property = RAD2DEG(Angle)
End Property

property Shot.SetLength( byval leng as single )
	Length = leng
End Property

''*****************************************************************************
''
''
''
''*****************************************************************************

sub Shot.Init( byref Posi as Vector2D, byval Degrees as integer, byval Col as integer, byref SpeedUp as Vector2D = Vector2D(0,0), byval leng as single = 20 )

	Active = TRUE
	Angle = DEG2RAD( Degrees )
	Colour = Col
	Power = 1
	Length = leng
	Position = Posi
	Direction = Vector2D( cos(Angle), sin(Angle) )  * SHOT_SPEED + SpeedUp
	TimeElapsed = 0
	
	Heading = Direction
	Heading.Normalize()
	
	dim as Vector2D v(2)
	
	v(0) = Vector2D( 0, 0 )
	v(1) = Vector2D( Heading * Length )
	v(2) = Vector2D( Heading * Length )
	
	Body.Reload( 3, v() )
	
end sub

sub Shot.Update( byval dt as single )

	TimeElapsed += dt
	Intensity = abs(sin(TimeElapsed * 7)) * 12
	Position += Direction * dt
	
	if( ( Position.x  < ( -60 ) ) or ( Position.x  > (SCREEN_WIDTH + 60) ) or _
		( Position.y  < ( -60 ) ) or ( Position.y  > (SCREEN_HEIGHT + 60) ) ) then
		Kill()
	end if
	
	Body.Reset()
	Body.Translate( Position.x, Position.y )
	Body.Transform()
	
end sub

function Shot.Collide( byref Poly as Polygon ) as integer
	
	return Body.Collide( Poly )
	
end function

sub Shot.Draw()

	'Body.Draw( 16, Colour )
	for i as integer = 0 to 3
		Body.Draw( 16 - ( i * Intensity ), Colour )
	next i
			
end sub

sub Shot.Kill()
	
	Active = FALSE
	Position = Vector2D( -3600, -3600 )
	Body.Reset()
	Body.Translate( Position.x, Position.y )
	Body.Transform()
	
end sub
	