''*****************************************************************************
''
''
''	Shot class
''	Richard Eric M. Lope
''	http://rel.phatcode.net
''
''	
''
''*****************************************************************************

#include once "FBGL2D7.bi"

#include once "Vector2D.bi"
#include once "Matrix2D.bi"
#include once "Polygon.bi"

#include once "Globals.bi"

#ifndef false
	const as integer FALSE = 0
	const as integer TRUE = NOT FALSE
#endif


''*****************************************************************************
''
''
''
''*****************************************************************************
type Shot
	
public:	
	'' constructors and destructors
	declare constructor()	
	declare destructor()	
	
	declare property IsActive() as integer
	declare property GetPosition() as Vector2D
	declare property GetDirection() as Vector2D
	declare property GetHeading() as Vector2D
	declare property GetPower() as integer
	declare property GetAngle() as integer
	declare property SetLength( byval leng as single )
	
	declare sub Init( byref Posi as Vector2D, byval Degrees as integer, byval Col as integer, byref SpeedUp as Vector2D = Vector2D(0,0), byval leng as single = 20 )
	declare sub Update( byval dt as single )
	declare function Collide( byref Poly as Polygon ) as integer
	declare sub Draw()
	declare sub Kill()
	
private:
	
	as integer	Active
	as single	Angle
	as single	Length
	as integer	Colour
	as integer	Power
	as single   Intensity
	as single   TimeElapsed
	
	as Vector2D	Position
	as Vector2D	Direction
	as Vector2D	Heading
	
	as Polygon	Body
	
end type

		